module Relation.Category (Category) where

import Relation.Base
import Relation.Reflexive
import Relation.Transitive

import Data.Kind (Constraint)

type Category :: Relation k -> Constraint
type Category r = (Reflexive r, Transitive r)
